library jaguar_mux.example.simple.client;

import 'dart:async';
import 'dart:io';
import 'dart:convert';

const String kHostname = 'localhost';

const int kPort = 8080;

final HttpClient _client = new HttpClient();

Future<Null> printHttpClientResponse(HttpClientResponse resp) async {
  StringBuffer contents = new StringBuffer();
  await for (String data in resp.transform(UTF8.decoder)) {
    contents.write(data);
  }

  print('=========================');
  print("body:");
  print(contents.toString());
  print("statusCode:");
  print(resp.statusCode);
  print("headers:");
  print(resp.headers);
  print("cookies:");
  print(resp.cookies);
  print('=========================');
}

Future<Null> execGetUser() async {
  HttpClientRequest req = await _client.get(kHostname, kPort, '/user/1');
  HttpClientResponse resp = await req.close();

  printHttpClientResponse(resp);
}

Future<Null> execVersion() async {
  HttpClientRequest req = await _client.get(kHostname, kPort, '/version');
  HttpClientResponse resp = await req.close();

  printHttpClientResponse(resp);
}

Future<Null> execInfo() async {
  HttpClientRequest req = await _client.get(kHostname, kPort, '/api/info');
  HttpClientResponse resp = await req.close();

  printHttpClientResponse(resp);
}

Future<Null> execGetQueryParams() async {
  HttpClientRequest req = await _client.get(
      kHostname, kPort, '/query/params?name=teja&password=secret');
  req.headers.set('hello', 'jaguar');
  HttpClientResponse resp = await req.close();

  printHttpClientResponse(resp);
}

Future<Null> execWrapEncodeMapToJson() async {
  HttpClientRequest req =
      await _client.get(kHostname, kPort, '/encode/maptojson');
  HttpClientResponse resp = await req.close();

  printHttpClientResponse(resp);
}

Future<Null> execWrapSimpleInterceptor() async {
  HttpClientRequest req =
      await _client.get(kHostname, kPort, '/wrap/simpleinterceptor');
  HttpClientResponse resp = await req.close();

  printHttpClientResponse(resp);
}

main() async {
  await execGetUser();
  await execVersion();
  //TODO await execInfo();
  await execGetQueryParams();
  await execWrapEncodeMapToJson();
  await execWrapSimpleInterceptor();
}
